//+------------------------------------------------------------------+
#property copyright "Daniel Jose"
//+------------------------------------------------------------------+
#define macroRandom (rand() / (double)SHORT_MAX)
//+------------------------------------------------------------------+
double Train[][2] {
                    {0, 0},
                    {1, 2},
                    {2, 4},
                    {3, 6},
                    {4, 8},
                  };
//+------------------------------------------------------------------+
const uint nTrain = Train.Size() / 2;
const double eps = 1e-3;
//+------------------------------------------------------------------+
double Cost(const double w)
{
    double err;

    err = 0;
    for (uint c = 0; c < nTrain; c++)
        err += MathPow((Train[c][0] * w) - Train[c][1], 2);

    return err / nTrain;
}
//+------------------------------------------------------------------+
void OnStart()
{
    double weight, err, e1;
    int f = FileOpen("Cost.csv", FILE_COMMON | FILE_WRITE | FILE_CSV);

    Print("The first neuron...");
    MathSrand(512);
    weight = (double)macroRandom;

    for(ulong c = 0; (c < ULONG_MAX) && ((e1 = Cost(weight)) > eps); c++)
    {
        err = (Cost(weight + eps) - e1) / eps;
        weight -= (err * eps);
        if (f != INVALID_HANDLE)
            FileWriteString(f, StringFormat("%I64u;%f;%f\n", c, err, e1));
    }
    if (f != INVALID_HANDLE)
        FileClose(f);
    Print("Weight: ", weight);
}
//+------------------------------------------------------------------+